
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define YYSTYPE char *

extern char *yytext;

int yyerror(char *s);
extern int yylex();

int label=0;
%}

%token ID BIN OCT DEC HEX ATRIB OP_COND FIM_INST WHILE IF THEN ELSE UP DOWN


%%

prog: prog inst FIM_INST {printf("\n");}
| inst FIM_INST {printf("\n");}

inst: atrib 
| whilecicle 
| ifthenelse

atrib: ID { printf("%s = ", yytext);} ATRIB  rhs 
| UP ID { printf("%s = %s + 1\n",yytext,yytext);}
| DOWN ID { printf("%s = %s - 1\n",yytext,yytext);}

rhs: BIN {printf("%ld", strtol(yytext+3,NULL,2));}
| OCT {printf("%ld", strtol(yytext+3,NULL,8));}
| DEC {printf("%s", yytext+3);}
| HEX {printf("%ld", strtol(yytext+3,NULL,16));}
| ID {printf("%s", yytext);}

whilecicle: WHILE {printf("L%d:\nifz ",label++);} cond {printf(" goto L%d\n",label);} atrib {printf("goto L%d\nL%d:",label-1,label);label++;}

ifthenelse: IF {printf("ifz ");} cond {printf(" goto L%d\n",label);} THEN atrib resto 

resto: ELSE {printf("goto L%d\nL%d:\n",label+1,label);label++;} atrib {printf("L%d:",label++);}
| {printf("\nL%d:",label++);}

cond: rhs OP_COND {printf(" %s ", yytext);} rhs 

%%

void main(){
yyparse();
}


int yyerror(char *s){puts(s);}
